//Library written by Jephtah....Phone number: 08132450841
#include "RoboticCar.h"

    RoboticCar::RoboticCar(byte In1, byte In2, byte In3, byte In4, byte enA, byte enB) {
      setDataMember(In1, In2, In3, In4, enA, enB);
      setPinModes();
    }

    //function to initialize the data members with the constructor parameters
    void RoboticCar::setDataMember(byte In1, byte In2, byte In3, byte In4, byte enA, byte enB) {
      input1 = In1;
      input2 = In2;
      input3 = In3;
      input4 = In4;
      enableA = enA;
      enableB = enB;
    }

    //function to set pin Modes
    void RoboticCar::setPinModes() {
      // In1 and In2 control motor output A
      pinMode(input1, OUTPUT);
      pinMode(input2, OUTPUT);
      pinMode(enableA, OUTPUT); //This is used to control the PWM/speed of motor outputA
      // In3 and In4 control motor output B
      pinMode(input3, OUTPUT);
      pinMode(input4, OUTPUT);
      pinMode(enableB, OUTPUT); //This is used to control the PWM/speed of motor outputB
    }

    //function to go forward
    void RoboticCar::forward(int roboticSpeed = 255) {
      analogWrite(enableA, roboticSpeed);
      analogWrite(enableB, roboticSpeed);
      digitalWrite(input1, HIGH);
      digitalWrite(input2, LOW);
      digitalWrite(input3, HIGH);
      digitalWrite(input4, LOW);
    }

    //function to go backward  
    void RoboticCar::reverse(int roboticSpeed = 255) {
      analogWrite(enableA, roboticSpeed);
      analogWrite(enableB, roboticSpeed);
      digitalWrite(input1, LOW);
      digitalWrite(input2, HIGH);
      digitalWrite(input3, LOW);
      digitalWrite(input4, HIGH);
    }

    //function to turn right
    void RoboticCar::right(int roboticSpeed = 255) {
      analogWrite(enableA, roboticSpeed);
      analogWrite(enableB, roboticSpeed);
      digitalWrite(input1, LOW);
      digitalWrite(input2, HIGH);
      digitalWrite(input3, HIGH);
      digitalWrite(input4, LOW);
    }

    //function to turn left
    void RoboticCar::left(int roboticSpeed = 255) {
      analogWrite(enableA, roboticSpeed);
      analogWrite(enableB, roboticSpeed);
      digitalWrite(input1, HIGH);
      digitalWrite(input2, LOW);
      digitalWrite(input3, LOW);
      digitalWrite(input4, HIGH);
    }

    //function to stop the motors from moving
    void RoboticCar::handBrake() {
      digitalWrite(input1, LOW);
      digitalWrite(input2, LOW);
      digitalWrite(input3, LOW);
      digitalWrite(input4, LOW);
    }
